<template>
  <div class="fullheight">
    <div style="display: flex">
      <el-form
        ref="searchForm"
        :model="searchForm"
        label-width="80px"
        class="searchTop"
      >
        <!-- <el-select
          v-model="searchForm.categoryId"
          placeholder="请选择病害类别"
          @change="changesele"
          clearable
        >
          <el-option
            v-for="item in getxu"
            :key="item.value"
            :label="item.label"
            :value="item.value"
          >
          </el-option>
        </el-select>
        <el-select
          v-model="searchForm.detailsId"
          placeholder="请选择病害细目"
          clearable
        >
          <el-option
            v-for="item in cbkm"
            :key="item.value"
            :label="item.label"
            :value="item.value"
          >
          </el-option>
        </el-select> -->
        <dict-select
          dictCode="bhlx"
          :hasDefaultOption="true"
          v-model="searchForm.diseaseCategory"
          placeholder="请选择病害类别"
          clearable
        />
        <el-select
          v-model="searchForm.roadName"
          placeholder="请选择路段"
          clearable
        >
          <el-option
            v-for="item in roadData"
            :key="item.key"
            :label="item.value"
            :value="item.value"
          >
          </el-option>
        </el-select>

        <dict-select
          dictCode="qlfx"
          :hasDefaultOption="true"
          clearable
          v-model="searchForm.direction"
          placeholder="请选择方向"
        />
        <el-button
          size="small"
          @click="findinfo()"
          type="primary"
        >查询</el-button>
      </el-form>
    </div>
    <el-divider></el-divider>

    <ht-table
      @load="loadData"
      :data="data"
      :pageResult="pageResult"
      :selection="true"
      :show-export="false"
      :show-custom-column="false"
      ref="htTable"
      :default-sorter="[{direction: 'DESC',property: 'id_'}]"
    >
      <template v-slot:toolbar>
        <div style="display: flex">
          <el-button
            size="small"
            @click="back()"
            icon="icon-withdraw"
            type="primary"
            plain
          >返回</el-button>
        </div>
      </template>
      <template>
        <ht-table-column
          prop="roadName"
          label="路段名称"
          :sortable="true"
          :show-overflow-tooltip="true"
        >
        </ht-table-column>
        <ht-table-column
          prop="diseaseCategory"
          label="病害类别"
          :show-overflow-tooltip="true"
        >
          <template v-slot="{row}">
            <div>{{ getDictName('bhlx', row.diseaseCategory) }}</div>
          </template>
        </ht-table-column>
        <ht-table-column
          prop="type"
          label="检查类别"
          :sortable="true"
          :show-overflow-tooltip="true"
        >
        </ht-table-column>
        <ht-table-column
          prop="description"
          label="病害描述"
          :show-overflow-tooltip="true"
        >
        </ht-table-column>
        <ht-table-column
          prop="direction"
          label="方向"
          :filters="getDictData('qlfx')"
          :show-overflow-tooltip="true"
        >
          <template v-slot="{row}">
            <el-tag>{{ getDictName('qlfx', row.direction) }}</el-tag>
          </template>
        </ht-table-column>
        <ht-table-column
          prop="subjectName"
          label="病害类别"
          :sortable="true"
          :show-overflow-tooltip="true"
        >
        </ht-table-column>
        <ht-table-column
          prop="dsubjectName"
          label="病害细目"
          :sortable="true"
          :show-overflow-tooltip="true"
        >
        </ht-table-column>
        <ht-table-column
          prop="positionName"
          label="病害部位"
          :sortable="true"
          :show-overflow-tooltip="true"
        >
          <!-- <template v-slot="{row}">
            <div>{{ getDictName('bhbw', row.position) }}</div>
          </template> -->
        </ht-table-column>
        <ht-table-column
          prop="handlingSituation"
          label="处理情况"
          :sortable="true"
          :show-overflow-tooltip="true"
        >
        </ht-table-column>
      </template>
    </ht-table>
  </div>
</template>

<script>
import BridgeDialog from '@/components/dialog/BridgeDialog.vue'
import req from '@/request.js'
import basicData from '@/api/basicData.js'
import DiseaseInforDialog from '@/components/dialog/DiseaseInformationDialog.vue'
import sctionInfoSelector from '@/components/selector/sctionInfoSelector.vue'
export default {
  components: {
    BridgeDialog,
    DiseaseInforDialog,
    sctionInfoSelector
  },
  name: 'Fretow',
  data() {
    return {
      searchForm: {},
      pageResult: {
        page: 1,
        pageSize: 20,
        total: 0
      },
      optionsss: [
        {value: '0', label: '否'},
        {value: '1', label: '是'}
      ],
      options: [],
      cbkm: [],
      data: [],
      row: [],
      selecdVlue: '',
      dialogVisible: false,
      form: {
        roadName: '',
        roadId: '',
        direction: 1,
        temporary: '0',
        type: 9
      },
      cbkmGD: ''
    }
  },
  created() {
    this.roadData = this.getroad()
    this.getxu = this.getxjlb()
  },
  methods: {
    getroad() {
      let arr = []
      basicData.getRoadManagement().then(res => {
        res.rows.forEach(item => {
          arr.push({
            value: item.name,
            key: item.name
          })
        })
        console.log(arr, '12')
      })
      return arr
    },
    getxjlb() {
      let arr = []
      let data = 'CBKM'
      basicData.getCostAccountManagement(data).then(res => {
        res.data.forEach(item => {
          arr.push({
            label: item.subjectName,
            value: item.subjectCode
          })
        })
      })
      return arr
    },
    changesele(value) {
      let arr = []
      basicData.getCostAccountManagement(value).then(res => {
        if (res.data.length > 0) {
          res.data.forEach(item => {
            if (item.pcode == value) {
              arr.push({
                label: item.subjectName,
                value: item.subjectCode
              })
            }
            this.cbkm = arr
          })
        }
      })
    },
    getDisease(row) {
      this.$refs.disease.open(row)
    },
    back() {
      this.$router.go(-1)
    },
    uniqueFunc(arr, uniId) {
      const res = new Map()
      return arr.filter(
        item => !res.has(item[uniId]) && res.set(item[uniId], 1)
      )
    },
    findinfo() {
      typeof this.$refs.filterTable !== 'undefined' &&
        this.$refs.filterTable.clearFilter()
      let query = []
      let params = {routeId: this.searchForm.routeId, flag: 1}
      let search = {
       disease_category_: this.searchForm.diseaseCategory,
        roadName: this.searchForm.roadName,
        direction: this.searchForm.direction,
      }
      for (let i in search) {
        if (search[i]) {
          query.push({
            group: 'advance',
            operation: 'LIKE',
            property: i,
            relation: 'AND',
            value: search[i]
          })
        }
      }
      query = this.uniqueFunc(query, 'property')
      let data = {
        pageBean: {
          page: 1,
          pageSize: 20,
          showTotal: true
        },
        querys: query,
        params: params
      }
      this.topQuery = query
      this.$http
        .post('${form}/disease/v1/getJsonCulvertDiseaseCheck', data)
        .then(res => {
          console.log(res, '11')
          let response = res.data
          this.data = response.rows
          this.pageResult = {
            page: response.page,
            pageSize: response.pageSize,
            total: response.total
          }
        })
    },
    loadData(param, cb) {
      if (this.row == '') {
        this.row = this.$route.params.row
      }
      param.params = {
        flag: 1
      }
      param.querys = [
        {
          group: 'main',
          operation: 'EQUAL',
          parentGroup: '',
          property: 'culvert_id_',
          relation: 'AND',
          value: this.row.id
        }
      ]
      if (typeof this.topQuery !== 'undefined' && this.topQuery.length !== 0) {
        param.querys = typeof param.querys !== 'undefined' ? param.querys : []
        this.topQuery.forEach(item => {
          param.querys.push(item)
        })
        param.querys = this.uniqueFunc(param.querys, 'property')
      }
      this.$http
        .post('${form}/disease/v1/getJsonCulvertDiseaseCheck', param)
        .then(
          resp => {
            let response = resp.data
            this.data = response.rows
            this.pageResult = {
              page: response.page,
              pageSize: response.pageSize,
              total: response.total
            }
            this.form.type = 9
          },
          error => {
            reject(error)
          }
        )
        .finally(() => {
          if (cb) {
            cb()
          }
        })
    }
  }
}
</script>

<style lang="scss" scoped>
.box {
  padding: 10px;
}
// /deep/ .el-main {
//   .el-table {
//     height: 745px !important;
//   }
// }
.el-dialog__header {
  border-bottom: 1px solid #eee;
}
/deep/ .el-date-editor.el-input,
.el-date-editor.el-input__inner {
  width: 100%;
}
/deep/.el-form-item__label {
  width: 100px;
}
.is-required:before {
  margin-right: 0;
}
/deep/.el-form-item__content {
  flex: 1;
  margin-left: 0 !important;
}
/deep/ .el-form-item__content .inputs {
  width: 100%;
}
/deep/ .el-select {
  width: 100%;
}
/deep/.el-dialog::-webkit-scrollbar {
  display: none;
}
/deep/.el-divider--horizontal {
  height: 10px;
  margin: 0 !important;
  position: absolute;
  left: 0;
}
/deep/.ht-table-panel {
  padding-top: 20px;
  height: calc(100% - 7%);
  overflow: hidden;
  background: #fff;
  display: flex;
  flex-direction: column;
  justify-content: space-between;
}
/deep/.ht-quick__search {
  margin-bottom: 10px;
}
/deep/.ht-table {
  height: calc(100% - 4vw) !important;
  max-height: calc(100% - 4vw) !important;
}
/deep/.pagination-panel {
  padding: 10px 0 0 0;
}
.searchTop > div {
  max-width: 200px;
}
</style>
